Module Supplier Contract
========================

Ce module crée un objet "Contrat fournisseur".

module n° 163106

# Todo
- Contact by default and consumption
- Product consumption
- Extrafields on add new supplier contract line to check if ok

## Contexte / Besoin

Gestion des contrats fournisseurs

## Pages

- `card.php` : card du contrat fournisseur
- `document.php` : pièces jointes
- `list.php` : liste
- `contact.php`: contact du contrat
- `agenda.php`: evenements du contrat
- `note.php` : note

- `messaging.php` : ??
- `services_list.php` : ??

- `stats/suppliercontract.php` : page permettant l'affichage des contrats fournisseurs "Objets référents" de produits.


## Modèles de documents

- `core/modules/suppliercontract/doc/pdf_suppliercontract_strato.modules.php`
- `core/modules/suppliercontract/doc/doc_generic_suppliercontract_odt.modules.php`

## Masques de numérotation

- `core/modules/suppliercontract/mod_suppliercontract_magre.php`
- `core/modules/suppliercontract/mod_suppliercontract_olive.php`
- `core/modules/suppliercontract/mod_suppliercontract_serpis.php`

## Objets / Classes spécifiques

- `suppliercontract.class.php`
  - there is a hack on getLisStatut() to use on consumption pages (ex. societe/consumption.php)
- `suppliercontractline.class.php`
- `api_suppliercontracts.class.php`
- `actions_suppliercontract.class.php`

## Constantes

- `SUPPLIERCONTRACT_ADDON`
- `SUPPLIERCONTRACT_ADDON_PDF`
- `SUPPLIERCONTRACT_ADDON_PDF_ODT_PATH`
- `SUPPLIERCONTRACT_FREE_TEXT`
- `SUPPLIERCONTRACT_DRAFT_WATERMARK`
- `SUPPLIERCONTRACT_HIDE_CLOSED_SERVICES_BY_DEFAULT`
- `SUPPLIERCONTRACT_ALLOW_EXTERNAL_DOWNLOAD`

## Extrafields

## Permissions

- 163157 : `lire` les contrats fournisseurs
- 163158 : `creer` les contrats fournisseurs
- 163159 : `activer` les contrats fournisseurs
- 163160 : `desactiver` les contrats fournisseurs
- 163161 : `supprimer` les contrats fournisseurs
- 163162 : `export` les contrats fournisseurs

## Menus

Dans le top menu 'Commerce' :
- un sous-menu "contrats fournisseur", qui contient :
  - une entrée "Nouveau contrat"
  - une entrée "liste"
  - une entrée "liste des services"
  - une entrée "liste des services inactifs"
  - une entrée "liste des services actifs"
  - une entrée "liste des services expirés"
  - une entrée "liste des services fermés"

## Hooks

- `addMoreActionsButtons` :
  - ajouter un bouton "créer un contrat fournisseur" sur un tiers
  - ajouter un bouton "créer un contrat fournisseur" sur un projet
  - ajouter un bouton "créer un contrat fournisseur" sur une propal fournisseur
  - ajouter un bouton "créer un contrat fournisseur" sur une commande fournisseur
  - ajouter un bouton "créer un contrat fournisseur" sur une facture fournisseur
  
- `addSearchEntry` : ??

- TODO...

- `addMoreProductStat` : affichage des contrats fournisseurs comme objets référents sur les produits
- `printFieldListSelect` : affichage des contrats fournisseurs comme objets référents sur les tiers. A GERER : sur les contacts 

## Triggers

- `LINEBILL_INSERT` : faire d'autres trucs

## Imports

## Exports

## Scripts

## Taches CRON

## Librairies

- `doSomething()` : fonction disponible dans la `lib/mymodule.lib.php` qui fait encore autre chose.

## ...

